# Typing information
import numpy as np
def naive(position : np.ndarray) -> np.ndarray: ...
def numpy(position : np.ndarray) -> np.ndarray: ...
def cupy(position : np.ndarray) -> np.ndarray: ...
def numpy_numba(position : np.ndarray) -> np.ndarray: ...
def numpy_numba_parallel(position : np.ndarray) -> np.ndarray: ...
def numba_gpu(position : np.ndarray) -> np.ndarray: ...
def sapporo(position : np.ndarray) -> np.ndarray: ...


import importlib

function_names = [
    'naive',
    'numpy',
    'cupy',
    'numpy_numba',
    'numpy_numba_parallel',
    'numba_gpu',
    'sapporo'
]

for function_name in function_names:
    _module = importlib.import_module('._' + function_name, __name__)
    globals()[function_name] = getattr(_module, 'calculate_potential')
del _module

