import numpy as np, cupy as cp

def calculate_potential(position : np.ndarray) -> np.ndarray:
    position = cp.array(position)
    N = len(position)
    mass = 1 / N
    potential = np.empty(N)
    for i in range(N):
        dx, dy, dz = (position[i,:] - position).T
        r = cp.sqrt(dx**2 + dy**2 + dz**2)
        r[i] = cp.inf
        potential[i]  = cp.sum(- mass / r)
    return potential