import numpy as np

def calculate_potential(position : np.ndarray) -> np.ndarray:
    N = len(position)
    mass = 1 / N
    potential = np.empty(N)
    for i in range(N):
        potential[i] = 0
        for j in range(N):
            if j == i: continue
            dx, dy, dz = position[i,:] - position[j,:]
            r = np.sqrt(dx**2 + dy**2 + dz**2)
            potential[i] += - mass / r
    return potential