import numpy as np

def calculate_potential(position : np.ndarray) -> np.ndarray:
    N = len(position)
    mass = 1 / N
    potential = np.empty(N)
    for i in range(N):
        dx, dy, dz = (position[i,:] - position).T
        r = np.sqrt(dx**2 + dy**2 + dz**2)
        r[i] = np.inf
        potential[i] = np.sum(- mass / r)
    return potential