import gravity_calculators, numpy as np
import time

if __name__ == '__main__':
    N = 1021 # Best to choose a prime
    np.random.seed(0)
    position = np.random.randn(N, 3)
    potential = np.empty((N, len(gravity_calculators.function_names)))
    for func_idx, function_name in enumerate(gravity_calculators.function_names):
        function = getattr(gravity_calculators, function_name)
        if function_name == 'sapporo':
            sapporo = gravity_calculators._sapporo.Sapporo()
            sapporo.set_j_particles(position)
            function = sapporo.calculate_potential
        potential[:,func_idx] = function(position)
    
    for func_idx, function_name in enumerate(gravity_calculators.function_names[1:]):
        max_deviation = abs(max(potential[:,func_idx+1] - potential[:,0]))
        print(f'Function: {function_name:20}  Maximum deviation: {max_deviation:.3E}')