import gravity_calculators, time, numpy as np, numba
import time

if __name__ == '__main__':
    num_cpus = 32
    max_time_per_func = 30000

    np.random.seed(0)
    numba.set_num_threads(num_cpus)
    N_array = 2**np.arange(7, 21, 1, dtype=int)
    position_ = np.random.randn(N_array[-1], 3)

    print(' '*20 + '% 10d'*len(N_array) % tuple(N_array))
    for func_idx, function_name in enumerate(gravity_calculators.function_names):
        function = getattr(gravity_calculators, function_name)
        if function_name == 'sapporo':
            sapporo = gravity_calculators._sapporo.Sapporo()
            sapporo.set_j_particles(position_)
            function = sapporo.calculate_potential
        start_func = time.perf_counter()
        print(f'{function_name:20}', end='', flush=True)
        for N_idx, N in enumerate(N_array):
            position = position_[:N]
            start = time.perf_counter()
            potential = function(position)
            end = time.perf_counter()
            elapsed = end - start
            print(f'{elapsed:10.3E}', end='', flush=True)
            if end - start_func > max_time_per_func:
                for N_idx in range(N_idx, len(N_array)-1): print(' nan      ', end='', flush=True)
                break
        print('')
