#include <algorithm>
#include <iostream>
#include <thrust/host_vector.h>
#include <thrust/device_vector.h>
#include <thrust/functional.h>
#include <thrust/transform.h>

int main()
{
  constexpr size_t n{1'000'000};
  thrust::host_vector<float> a(n, 2.), b(n, 3.);

  thrust::device_vector<float> a_dev{a}, b_dev{b};

  thrust::transform(a_dev.begin(), a_dev.end(), b_dev.begin(),
                    b_dev.begin(), thrust::plus<float>());

  b = b_dev;

  if (std::all_of(begin(b), end(b), [](const auto x){ return x == 5.; }))
    std::cout << "Success!\n";
  else std::cout << "Failure :(\n";
}