#include <algorithm>
#include <iostream>

int main()
{
  constexpr size_t n{1'000'000};
  float *a{new float[n]}, *b{new float[n]};
  std::fill(a, a+n, 2.);
  std::fill(b, b+n, 3.);

  #pragma omp target data map(to: a[:n]) map(tofrom: b[:n])
  #pragma omp target parallel for
  for (int i = 0; i < n; i++)
    b[i] = a[i] + b[i];

  if (std::all_of(b, b+n, [](const auto x){ return x == 5.; }))
    std::cout << "Success!\n";
  else std::cout << "Failure :(\n";

  delete[] a;
  delete[] b;
}