from numba import vectorize
import numpy as np

@vectorize('float32(float32, float32)', target='cuda')
def add(a, b):
  return a + b

if __name__ == '__main__':
  n = 1_000_000
  a = np.full(n, 2., dtype=np.float32)
  b = np.full(n, 3., dtype=np.float32)

  b = add(a, b)

  if all(b == 5.): print('Success!')
  else: print('Failure :(')